
/***  (c) 2010, STRYK System Improvement, Jrg Stryk   ***/
/***                   www.stryk.info                  ***/

-- Investigate Blocks

USE [Decisions2010]  -- select NAV database here
GO

-- Blocks per Resource, Blocked User and Blocking User
SELECT [db],
       convert(datetime, convert(varchar(20),[start_time], 0)) as [timestamp],
       [waitresource], 
       [table_name], 
       [index_name], 
       [blocked_login], 
       [blocking_login], 
       [count] = COUNT(*), 
       (select MAX([waittime]) 
        from ssi_BlockLog b2 
        where b2.[db] = b1.[db] and
              b2.[waitresource] = b1.waitresource and 
              b2.[table_name] = b1.table_name and 
              isnull(b2.[index_name], '') = isnull(b1.index_name, '') and 
              b2.[loginame] = b1.[blocked_login] and
              b2.[loginame 2] = b1.[blocking_login])
       as [max_duration], 
       (select AVG([waittime]) 
        from ssi_BlockLog b2 
        where b2.[db] = b1.[db] and
              b2.[waitresource] = b1.waitresource and 
              b2.[table_name] = b1.table_name and 
              isnull(b2.[index_name], '') = isnull(b1.index_name, '') and
              b2.[loginame] = b1.[blocked_login] and
              b2.[loginame 2] = b1.[blocking_login])
       as [avg_duration] 
FROM (select distinct [db], [start_time], [waitresource], [table_name], [index_name],
                      [blocked_login] = [loginame], [blocking_login] = [loginame 2] 
      from  ssi_BlockLog) b1
GROUP BY [db], convert(datetime, convert(varchar(20),[start_time], 0)),[waitresource], [table_name],
         [index_name], [blocked_login], [blocking_login]
ORDER BY [count] DESC
GO

-- Blocks per hours
SELECT [db], convert(datetime, convert(datetime, left(convert(varchar(20),[start_time], 113), 14) + ':00')) as [time], [blocks_per_hour] = COUNT(*)
FROM (select distinct [db],[start_time] from  ssi_BlockLog) b1
GROUP BY [db], convert(datetime, left(convert(varchar(20),[start_time], 113), 14) + ':00')
ORDER BY [db], convert(datetime, left(convert(varchar(20),[start_time], 113), 14) + ':00')


-- Affected queries
SELECT [cmd] AS [query], count(*) AS [occurrence] 
FROM ssi_BlockLog
GROUP BY [cmd]
ORDER BY count(*) DESC, [cmd]
GO